.button {
  position: relative;
  cursor: pointer;
  pointer-events: auto;
  display: block;
  min-width: 125px;
  width: 100%;
  max-width: 100%;
  padding: 10px 32px;
  background-color: var(--btn-bg-color-primary);
  border-radius: 5px;
  border: 2px solid var(--btn-bg-color-primary);
  overflow: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
  font-family: var(--font-family);
  font-weight: 700;
  font-size: 16px;
  color: var(--btn-font-color-primary);
  opacity: 1;
  transform: scale(1);
  transition: background-color 0.25s ease-in-out, color 0.25s ease-in-out, opacity 0.25s ease-in-out,
    border-color 0.25s ease-in-out, transform 0.25s ease-in-out;

  @media (hover: hover) and (pointer: fine) {
    &:hover {
      opacity: 0.75;
    }
  }

  &:active {
    opacity: 1;
  }

  @media (hover: none) {
    &:active {
      transform: scale(0.95);
    }
  }

  &.disable {
    pointer-events: none;
    opacity: 0.65;
  }

  &.loading {
    pointer-events: none;
  }

  &.secondary {
    background-color: transparent;
    border-color: var(--btn-bg-color-secondary);
    color: var(--btn-bg-color-secondary);
  }

  &.tertiary {
    background-color: transparent;
    border-radius: 0;
    border-color: transparent;

    &:after {
      content: '';
      position: absolute;
      width: 0;
      height: 2px;
      bottom: 0;
      left: 50%;
      transform: translateX(-50%);
      background-color: var(--btn-font-color-primary);
      transition: width 0.25s ease-in-out;
    }

    @media (hover: hover) and (pointer: fine) {
      &:hover {
        opacity: 1;

        &:after {
          width: 100%;
        }
      }
    }

    &:active {
      opacity: 0.75;
    }
  }

  &.large {
    min-width: 300px;
  }

  &.only_svg {
    min-width: unset;
    width: unset;
    max-width: unset;
    padding: 10px;
  }

  &__svg {
    display: grid;
    grid-template-columns: 18px auto;
    align-items: center;
    width: fit-content;
    margin: 0 auto;
    fill: var(--btn-font-color-primary);

    & > * {
      &:nth-child(2) {
        margin-left: 10px;
        overflow: hidden;
        white-space: nowrap;
        text-overflow: ellipsis;
      }
    }

    &.secondary {
      fill: var(--btn-bg-color-secondary);
    }
  }

  &__preloader {
    position: absolute;
    pointer-events: none;
    display: flex;
    justify-content: center;
    align-items: center;
    width: 100%;
    height: 100%;
    top: 0;
    left: 0;
    background-color: inherit;

    &__loader {
      position: relative;
      width: 30px;
      height: 30px;
      border: 3px solid rgba(255, 255, 255, 0.55);
      border-radius: 50%;

      &:before {
        content: '';
        position: absolute;
        width: 100%;
        height: 100%;
        left: -3px;
        top: -3px;
        border-radius: 50%;
        border: 3px solid transparent;
        border-top-color: #ffffff;
        animation: load8 1.1s infinite linear;
      }
    }
  }

  @media all and (min-width: 768px) {
    width: unset;
  }

  @keyframes load8 {
    0% {
      transform: rotate(0deg);
    }
    100% {
      transform: rotate(360deg);
    }
  }
}
